package ij.gui;

import ij.IJ;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Window;

import javax.swing.JFrame;
import java.awt.Toolkit;
import java.awt.Point;
import ij.Prefs;
import ij.ImageJ;

/** This class consists of static GUI utility methods. */
public class GUI {

    public static int cw = 0;
    public static int cwl = 0;
        /** Positions the specified window in the center of the screen. */
        public static void center(Window w) {
                Dimension screen = IJ.getScreenSize();
                Dimension window = w.getSize();
                if (window.width==0)
                        return;
                int left = screen.width/2-window.width/2;
                int top = (screen.height-window.height)/4;
                if (top<0) top = 0;
                w.setLocation(left, top);
        }
        /** Positions the specified window in the center of the screen. */
        public static void relCenter(ImageJ ij, Window w) {
            String menuItemNum = Prefs.getString("menuItemCount");
            int maxCount=Integer.parseInt(menuItemNum);
            Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
            if(cw > maxCount) cw=0;
            cw++;
            Dimension window = w.getPreferredSize();
            Dimension ijw = ij.getPreferredSize();
            Point ijp = ij.getLocation();
            if (window.width==0)
                    return;
            int left = ijp.x+ijw.width-window.width;
            int top = (int)(ijp.y+ijw.getHeight()+(cw-1)*window.height);
            if (top<0) top = 0;
            w.setLocation(left, top);
        }
        /** Positions the specified window in the center of the screen. */
        public static void relRight(ImageJ ij, Window w) {
            String menuItemNum = "1";//Prefs.getString("menuItemCount");
            int maxCount=Integer.parseInt(menuItemNum);
            Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
            if(cwl > maxCount) cwl=0;
            cwl++;
            Dimension window = w.getPreferredSize();
            Dimension ijw = ij.getPreferredSize();
            Point ijp = ij.getLocation();
            if (window.width==0)
                    return;
            int right = ijp.x;
            int top   = (int)(ijp.y+ijw.getHeight());
            //int top = (int)(ijp.y+ijw.getHeight()+(cwl-1)*window.height);
            if (top<0) top = 0;
            w.setLocation(right, top);
        }


    static private JFrame frame;

    /** Creates a white AWT Image image of the specified size. */
    public static Image createBlankImage(int width, int height) {
        if (width==0 || height==0)
            throw new IllegalArgumentException("");
                if (frame==null) {
                        frame = new JFrame();
                        frame.pack();
                        frame.setBackground(Color.white);
                }
        Image img = frame.createImage(width, height);
        return img;
    }

}
