package ij.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;

import javax.swing.JPanel;
import javax.swing.JFrame;

import ij.gui.GUI;
import ij.IJ;
import ij.ImageJ;
import ij.gui.Toolbar;
import ij.WindowManager;
import ij.plugin.frame.PlugInFrame;
import java.awt.Point;
import ij.Prefs;
import ij.IJEventListener;
import ij2x.plugin.CollapsiblePane;

public class ToolBox extends PlugInFrame implements ActionListener {
    protected ImageJ ij;
    protected JPanel panel = new JPanel();
    private Toolbar toolBar = new Toolbar();
    private JFrame instance;
    static final String LOC_KEY = "tbf.loc";

    public ToolBox() {
        super("Tool Box");

    }

    public void run(String arg){
        instance=WindowManager.getFrame("Tool Box");
        if (instance!=null) {
            instance.toFront();
            toolBar.repaint();
            return;
        }

        ij = IJ.getInstance();
        ij.installStartupMacroSet(ij.getMenus());
        toolBar.setToolbarDim(Toolbar.NUM_COLUMN_BUTTONS);
        container.add(toolBar);
        pack();
        WindowManager.addWindow(this);
        Point loc = Prefs.getLocation(LOC_KEY);
        if (loc!=null)
                setLocation(loc);
        else GUI.relRight(ij, this);

        setResizable(false); // make resizable on Linux
        setVisible(true);
    }

    /** Closes this window. */
    public void close() {
        super.close();
        instance = null;
        Prefs.saveLocation(LOC_KEY, getLocation());
        IJ.notifyEventListeners(IJEventListener.COLOR_PICKER_CLOSED);
    }

    // Action listener method
    public void actionPerformed(ActionEvent e){
    }
     /** WindowsListener methods        */
     public void windowActivated(WindowEvent e) {
         ImageJ ij = IJ.getInstance();
         boolean quitting = ij!=null && ij.quitting();
     }

     public void windowClosing(WindowEvent e) {
                     CollapsiblePane.toolboxButton.setEnabled(true);
                     GUI.cwl--;
                     close();
     }

     public void windowClosed(WindowEvent e) {}
     public void windowDeactivated(WindowEvent e) {}
     public void windowDeiconified(WindowEvent e) {}
     public void windowIconified(WindowEvent e) {}
     public void windowOpened(WindowEvent e) {}


}


