/*
 * $Id: AboutBox.java,v 1.0, rawak.de $
 *
 * Copyright (c) 2001-2011 by the authors of ImageJ2x
 * All rights reserved.
 *
 *
 */
package ij.plugin;

import ij.*;
import ij.gui.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import javax.swing.JWindow;
import java.awt.geom.AffineTransform;
import ij2x.plugin.event.WindowsListener;
import java.lang.reflect.Method;
import javax.swing.JComponent;
import java.beans.PropertyChangeSupport;
import java.beans.PropertyChangeListener;
import javax.swing.ImageIcon;
import javax.swing.Icon;
import java.net.URL;


public class AboutBox extends JComponent implements PlugIn, ActionListener, MouseListener, MouseMotionListener
{
    private FontMetrics fm;
    private boolean pressed = false;
    private boolean hit= false;
    private WindowsListener listener;
    private PropertyChangeSupport pcs;
    private Shape rectangle, rect;
    private JWindow win;
    private Container container;
    private Image image, imageIcon, macIcon, parentIcon;
    private int progress;
    private static final int PROGRESS_HEIGHT = 20;
    private Font currentFont;
    private Font font_10;
    private Font font_12;
    private Font font_14;
    private Font font_15;
    private Font font_50;
    private int offsetX = 20;
    private int offsetY = 60;
    private ImageJ ij;
    private static String fileType = ".png";
    private static String dir;
    private String productName = ImageJ.PRODUCT_NAME;
    private static String[] text = {
    ImageJ.PRODUCT_NAME+" "+ImageJ.VERSION,
    "Wayne Rasband",
        "National Institutes of Health, USA",
         " ",
      "autor: rawak.de",
            "http://www.rawak.de/ij2x/Download.html",
            "java version: " + System.getProperty("java.version")+(IJ.is64Bit()?" (64-bit)":" (32-bit)"),
       "freememory: "+ IJ.freeMemory(),
     "os name: "+System.getProperty("os.name"),
         "ImageJ2x is in the public domain",
    };

    /**
        * Try's to make the given {@link Window} non-opqaue (transparent) across
        * platforms and JREs. This method is not guaranteed to succeed, and will fail
        * silently if the given {@code Window} cannot be made non-opaque.
        *
        * This method is useful, for example, when creating a HUD style window that
        * is semi-transparent, and thus doesn't want the window background to be
        * drawn.
        * @param window the {@code Window} to make non-opaque.
        */
       public static void makeWindowNonOpaque(Window window) {
           // on the mac, simply setting the window's background color to be fully
           // transparent makes the window non-opaque.
           window.setBackground(new Color(0, 0, 0, 0));
           // on non-mac platforms, try to use the facilities of Java 6 update 10.
           if (!IJ.isMacOSX()) {
               quietlyTryToMakeWindowNonOqaque(window);
           }
       }

       /**
        * Trys to invoke {@code com.sun.awt.AWTUtilities.setWindowOpaque(window, false)}
        * on the given {@link Window}. This will only work when running with JRE 6 update 10
        * or higher. This method will silently fail if the method cannot be invoked.
        * @param window the {@code Window} to try and make non-opaque.
        */
       private static void quietlyTryToMakeWindowNonOqaque(Window window) {
           try {
               Class clazz = Class.forName("com.sun.awt.AWTUtilities");
               Method method =
                       clazz.getMethod("setWindowOpaque", java.awt.Window.class, Boolean.TYPE);
               method.invoke(clazz, window, false);
           } catch (Exception e) {
               // silently ignore this exception.
           }
       }
       public AboutBox()
        {
                setBackground(Color.white);
                pcs = new PropertyChangeSupport(this);

                font_10 = new Font("Dialog",Font.BOLD,10);
                font_12 = new Font("Dialog",Font.BOLD,12);
                font_14 = new Font("Dialog",Font.PLAIN | Font.ITALIC,14);
                font_15 = new Font("Dialog",Font.BOLD,15);
                font_50 = new Font("Dialog",Font.BOLD,46);

                dir = Prefs.getString("aboutimg1");
                image=((ImageIcon)createIcon("splash_blue_07")).getImage();
                dir = Prefs.getString("aboutimg2");
                imageIcon=((ImageIcon)createIcon("nonmac")).getImage();
                dir = Prefs.getString("aboutimg3");
                macIcon=((ImageIcon)createIcon("apple_04")).getImage();
                parentIcon = IJ.isMacintosh() ? macIcon : imageIcon;
                ij = IJ.getInstance();
                win = new JWindow();
                container = win.getContentPane();
                makeWindowNonOpaque(win);

                Dimension screen = getToolkit().getScreenSize();
                Dimension size = new Dimension(image.getWidth(this),
                        image.getHeight(this));
                win.setSize(size);
                int lines=text.length;
                int[] widths = new int[lines];
                widths[0] = text[0].length();
                for (int i=1; i<lines-1; i++){
                    widths[i] = text[i].length();
                }
                int max = 0;
                for (int i=0; i<lines-1; i++){
                    if (widths[i] > max)
                        max = widths[i];
                }
                listener = new WindowsListener(this);
                addMouseListener(this);
                addMouseMotionListener(this);
                addMouseListener(listener);
                addMouseMotionListener(listener);
                addComponentListener(listener);
                container.add(BorderLayout.CENTER,this);
                rectangle=new Rectangle(image.getWidth(null)-parentIcon.getWidth(null)+34-5,parentIcon.getHeight(null)/2-5, parentIcon.getWidth(null)-34, parentIcon.getHeight(null));
                rect=new Rectangle(image.getWidth(null)-parentIcon.getWidth(null)-5,parentIcon.getHeight(null)/2-5, parentIcon.getWidth(null), parentIcon.getHeight(null));

                win.setLocation((screen.width - size.width) / 2,
                        (screen.height - size.height) / 2);
                win.validate();
                GUI.relCenter(ij, win);
                GUI.cw=0;
                win.setVisible(true);
         }
         private Icon createIcon(String key){
             Icon icon = null;
             String fileName=key + getFileType();
             if(getImageDir() == null){
              dir="images/";
             }
             String path = getImageDir()+fileName;
            try {
                URL url = this.getClass().getResource(path);
                Image image = Toolkit.getDefaultToolkit().createImage(url);
                if (url != null) {
                    icon = new ImageIcon(image);
                  }
                } catch (Exception ex) {
              }
                return icon;
         }

         private String getFileType(){
                return fileType;
         }
         private String getImageDir(){
                return dir;
         }

        public void run(String arg) {
            advance();
        }
        public void dispose()
        {
                win.dispose();
        }

        public synchronized void advance()
        {
                progress++;
                repaint();

                try
                {
                        wait();
                }
                catch(InterruptedException ie)
                {
                }
        }

        public synchronized void paintComponent(Graphics g)
        {
               Graphics2D g2D = (Graphics2D)g;
               Dimension size = getSize();

                if(parentIcon== null)
                parentIcon = IJ.isMacintosh() ? macIcon : imageIcon;
                g2D.drawImage(image,0,0,this);
                g2D.drawImage(parentIcon,image.getWidth(null)-parentIcon.getWidth(null)-5,parentIcon.getHeight(null)/2-5,this);

                g2D.setColor(new Color(248, 1, 5));
                g2D.setFont(font_50);
                AffineTransform trans = new AffineTransform();
                trans.setToRotation(0);
                trans.rotate(-90.0*Math.PI/180.0, 67, image.getHeight(this)-10);
                g2D.transform(trans);
                g2D.drawString(productName, 67, image.getHeight(this)-18);

                g2D.setColor(new Color(164, 4, 4));
                g2D.drawString(productName, 65, image.getHeight(this)-13);

                currentFont=font_12;
                fm = getFontMetrics(currentFont);
                g2D.setFont(currentFont);
                g2D.setTransform(new AffineTransform());

                g2D.setColor(new Color(67, 217, 5));

                int y = (fm.getAscent() + fm.getDescent());
                for(int i= 0; i < text.length; i++){
                    if(i == 0){
                        g2D.drawString(text[i],
                                       (getWidth() +offsetX - fm.stringWidth(text[i])) / 2,
                                       y+offsetY);
                    }else if(i < text.length-1){
                        g2D.drawString(text[i],
                                       (getWidth() + offsetX - fm.stringWidth(text[i])) / 2,
                                       ((i+1) * y)+offsetY);
                    }else{
                        g2D.setColor(new Color(248, 1, 5));
                        g2D.drawString(text[i],
                                       (getWidth() + offsetX - fm.stringWidth(text[i])) / 2,
                                       (getHeight())-5);
                    }
                }
                String str2 = "Rawak Software";

                currentFont=font_10;
                fm = getFontMetrics(currentFont);
                g2D.setFont(currentFont);
                g2D.setColor(new Color(248, 1, 5));
                g2D.drawString(str2, 10+getWidth()/2, 24-y/2);

                notify();
        }

        public void mousePressed(MouseEvent e) {
            pressed = true;

         }

         public void mouseReleased(MouseEvent e) {
            win.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
         }
         public void mouseExited(MouseEvent e) {}
         public void mouseClicked(MouseEvent e) {
             if(pressed && e.getClickCount() == 1 && rectangle.getBounds().contains(e.getPoint()))
                 {win.dispose();
                     pressed=false;
                 }
         }
         public void mouseEntered(MouseEvent e) {
         }


         public void mouseMoved(MouseEvent e) {
         if(rectangle.getBounds().contains(e.getPoint())){
             win.setCursor(new Cursor(Cursor.HAND_CURSOR));
             hit=true;
         }else{
             win.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
             hit=false;
        }
         }
         public void mouseDragged(MouseEvent e) {
             if(!hit && !rect.getBounds().contains(e.getPoint()))
             win.setCursor(new Cursor(Cursor.MOVE_CURSOR));
             else return;
         }

        public void actionPerformed(ActionEvent e){
            win.dispose();
        }
        public void addPropertyChangeListener(PropertyChangeListener p){
           pcs.addPropertyChangeListener(p);
        }

         public void removePropertyChangeListener(PropertyChangeListener p){
            pcs.removePropertyChangeListener(p);
        }
}
